# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes | List of all members
dirac::PixelMatcher Class Reference

`#include <pixel_match.h>`

Collaboration diagram for dirac::PixelMatcher:
[legend]

## Public Member Functions
| PixelMatcher (const EncoderParams &encp)
| Constructor. More...
void | DoSearch (EncQueue &my_buffer, int pic_num)
| Do the actual search. More...

## Private Member Functions
void | MakePicHierarchy (const PicArray &data, OneDArray< PicArray * > &down_data)
| Make down-converted pictures. More...
void | MakeMEDataHierarchy (const OneDArray< PicArray * > &down_data, OneDArray< MEData * > &me_data_set)
| Make a hierarchy of MvData structures. More...
void | TidyPics (OneDArray< PicArray * > &down_data)
| Tidy up the allocations made in building the picture hirearchy. More...
void | TidyMEData (OneDArray< MEData * > &me_data_set)
| Tidy up the allocations made in building the MV data hirearchy. More...
void | MatchPic (const PicArray &ref_data, const PicArray &pic_data, MEData &me_data, const MvData &guide_data, const int ref_id)
| Match the picture data. More...
void | DoBlock (const int xpos, const int ypos, const MvArray &guide_array, BlockMatcher &block_match)
| Do a given block. More...

## Private Attributes
const EncoderParams & | m_encparams
| Local reference to the encoder params. More...
const PicturePredParams * | m_predparams
| Local reference to the picture pred params. More...
int | m_depth
int | m_level
int | m_xr
int | m_yr
int | m_big_xr
int | m_big_yr
int | m_tdiff [2]
PictureSort | m_psort
CandidateList | m_cand_list
MVector | m_mv_prediction
double | m_rho
double | m_cost_mean
double | m_cost_mean_sq

## Constructor & Destructor Documentation

## ◆ PixelMatcher()

dirac::PixelMatcher::PixelMatcher | ( | const EncoderParams & | encp | ) |

## Member Function Documentation

## ◆ DoBlock()

void dirac::PixelMatcher::DoBlock | ( | const int | xpos,
|  | const int | ypos,
|  | const MvArray & | guide_array,
|  | BlockMatcher & | block_match
| ) |  |
| private

## ◆ DoSearch()

void dirac::PixelMatcher::DoSearch | ( | EncQueue & | my_buffer,
|  | int | pic_num
| ) |  |

## ◆ MakeMEDataHierarchy()

void dirac::PixelMatcher::MakeMEDataHierarchy | ( | const OneDArray< PicArray * > & | down_data,
|  | OneDArray< MEData * > & | me_data_set
| ) |  |
| private

## ◆ MakePicHierarchy()

void dirac::PixelMatcher::MakePicHierarchy | ( | const PicArray & | data,
|  | OneDArray< PicArray * > & | down_data
| ) |  |
| private

## ◆ MatchPic()

void dirac::PixelMatcher::MatchPic | ( | const PicArray & | ref_data,
|  | const PicArray & | pic_data,
|  | MEData & | me_data,
|  | const MvData & | guide_data,
|  | const int | ref_id
| ) |  |
| private

## ◆ TidyMEData()

void dirac::PixelMatcher::TidyMEData | ( | OneDArray< MEData * > & | me_data_set | ) |
| private

## ◆ TidyPics()

void dirac::PixelMatcher::TidyPics | ( | OneDArray< PicArray * > & | down_data | ) |
| private

## Member Data Documentation

## ◆ m_big_xr

int dirac::PixelMatcher::m_big_xr
| private

## ◆ m_big_yr

int dirac::PixelMatcher::m_big_yr
| private

## ◆ m_cand_list

CandidateList dirac::PixelMatcher::m_cand_list
| private

## ◆ m_cost_mean

double dirac::PixelMatcher::m_cost_mean
| private

## ◆ m_cost_mean_sq

double dirac::PixelMatcher::m_cost_mean_sq
| private

## ◆ m_depth

int dirac::PixelMatcher::m_depth
| private

## ◆ m_encparams

const EncoderParams& dirac::PixelMatcher::m_encparams
| private

## ◆ m_level

int dirac::PixelMatcher::m_level
| private

## ◆ m_mv_prediction

MVector dirac::PixelMatcher::m_mv_prediction
| private

## ◆ m_predparams

const PicturePredParams* dirac::PixelMatcher::m_predparams
| private

## ◆ m_psort

PictureSort dirac::PixelMatcher::m_psort
| private

## ◆ m_rho

double dirac::PixelMatcher::m_rho
| private

## ◆ m_tdiff

int dirac::PixelMatcher::m_tdiff[2]
| private

## ◆ m_xr

int dirac::PixelMatcher::m_xr
| private

## ◆ m_yr

int dirac::PixelMatcher::m_yr
| private

The documentation for this class was generated from the following file:

- pixel_match.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.